﻿select Identifier, DateStamp, Status from (
	select distinct
		Saker.accnr as Identifier,
		max(SakerDatum.DateStamp) as DateStamp,
		case when avregistrerad = 1 then 'deleted' else NULL end as Status
	from Saker
	inner join (
		select Saker.accnr as Identifier, case when Saker.regdatum is null then '1987-01-01' else Saker.regdatum end as DateStamp from Saker
		union
		select Saker.accnr as Identifier, (select top 1 TxtArkiv.Dt from TxtArkiv where Saker.accnr = TxtArkiv.TableKey and TxtArkiv.TableName = 'Foremal' and TxtArkiv.Dt is not null order by TxtArkiv.Dt desc) as DateStamp from Saker
		union
		select Saker.accnr as Identifier, (select top 1 BildSaker.datum from BildSaker where Saker.accnr = BildSaker.accnr order by BildSaker.datum desc) as DateStamp from Saker
	) SakerDatum on SakerDatum.Identifier = Saker.accnr
	inner join SakPlac on Saker.accnr = SakPlac.accnr
	inner join SakNamn on SakNamn.accnr = Saker.accnr
	where Saker.webKlar = 1 and (SakNamn.kategori = 'G' or SakNamn.kategori = 'I')
	group by Saker.accnr, Saker.avregistrerad
) x where Identifier = '${id}'