﻿using System.Collections.Generic;
using System.Diagnostics;
using ServiceCore.ServiceComponents;

namespace ServiceCore.ServiceComponents
{
	public class Collection {
		public string Id { get; private set; }
		public bool MultiFetch { get; private set; }
		public int ZeroPadRowNumber { get; private set; }
		public int MaxRowNumber { get; private set; }
		public DataSource DataSource { get; private set; }
		public Dictionary<string, NamedData> Data { get; private set; }
		public List<string> OrderedDataKeys { get; private set; }
		public Dictionary<string, Field> Fields { get; private set; }
		public Output Output { get; private set; }
		public Dictionary<string, AdditionalOutput> AdditionalOutputs { get; private set; }
		public string Delimiter { get; private set; }

		public Collection(string id, DataSource ds, string delimiter, bool multiFetch, int zeroPadRowNumber, int maxRowNumber) {
			Id = id;
			DataSource = ds;
			Data = new Dictionary<string, NamedData>();
			OrderedDataKeys = new List<string>();
			Fields = new Dictionary<string, Field>();
			Output = new Output();
			AdditionalOutputs = new Dictionary<string, AdditionalOutput>();
			Delimiter = delimiter;
			MultiFetch = multiFetch;
			ZeroPadRowNumber = zeroPadRowNumber;
			MaxRowNumber = maxRowNumber;

#if DEBUG
			//Debug.WriteLine(string.Format("Collection: {0}", id));
#endif
		}
	}
}