﻿using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

namespace ServiceCore.ServiceComponents
{
	public class ConditionalData : NamedData {
		public NamedData Source { get; private set; }
		public Output Output { get; private set; }

		public ConditionalData(string id, NamedData source) {
			Id = id;
			Source = source;
			Output = new Output();

#if DEBUG
			//Debug.WriteLine(string.Format("Conditional Data: {0}", id));
#endif
		}

		public override string GetValue(IDictionary<string, string> templates, IDictionary<string, string> values) {
			if (string.IsNullOrEmpty(values[Source.Id]))
				return "";

			var value = new StringBuilder(templates[Output.Template]);

			foreach (var dataTemplate in Output.DataTemplates) {
				value.Replace(string.Format("${{{0}}}", dataTemplate.Key), dataTemplate.Value.GetValue(templates, values));
			}

			values[Id] = value.ToString();
			return values[Id];
		}
	}
}