﻿using System;
using System.Diagnostics;

namespace ServiceCore.ServiceComponents
{
	public class Connection {
		public String Id { get; private set; }
		public String ConnectionString { get; private set; }
		public ConnectionType Type { get; private set; }

		public enum ConnectionType {
			SQL2005,
			MYSQL,
			ACCESS,
			OTHER
		}

		public Connection(string id, string connectionString, string type) {
			Id = id;
			ConnectionString = connectionString;
			Type = ConvertType(type);

#if DEBUG
			//Debug.WriteLine(string.Format("Connection: {0}", id));
#endif
		}

		private static ConnectionType ConvertType(string type) {
			switch (type) {
				case "SQL2005":
					return ConnectionType.SQL2005;
				case "MYSQL":
					return ConnectionType.MYSQL;
				case "ACCESS":
					return ConnectionType.ACCESS;
				default:
					return ConnectionType.OTHER;
			}
		}
	}
}