﻿using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Web;
using OAI.Util;

namespace ServiceCore.ServiceComponents
{
	public class DataTemplate : NamedData {
		public string Value { get; private set; }
		public List<Parameter> Parameters { get; private set; }
		public bool UrlEncode { get; private set; }

		public DataTemplate(string id, string value, bool urlEncode) {
			Id = id;
			Value = value;
			Parameters = new List<Parameter>();
			UrlEncode = urlEncode;
#if DEBUG
			//Debug.WriteLine(string.Format("Data Template: {0}", id));
#endif
		}

		public override string GetValue(IDictionary<string, string> templates, IDictionary<string, string> values) {
			var value = new StringBuilder(Value);

			var parameters = new string[Parameters.Count];
			foreach (var parameter in Parameters) {
				parameters[parameter.Index] = parameter.Source.GetValue(templates, values); 				
			}

			values[Id] = string.Format(value.ToString(), parameters);

			if (UrlEncode) {
				values[Id] = HttpUtility.UrlEncode(values[Id]);
			}

			return OAIUtil.XmlEncode(values[Id]);
		}
	}
}