﻿using System.Collections.Generic;
using System.Diagnostics;
using OAI.Util;

namespace ServiceCore.ServiceComponents
{
	public class DataTranslation : NamedData {
		public NamedData Source { get; private set; }
		public Dictionary<string, NamedData> Translations { get; private set; }
		public DataTranslation(string id, NamedData source) {
			Id = id;
			Source = source;
			Translations = new Dictionary<string, NamedData>();
#if DEBUG
			//Debug.WriteLine(string.Format("Data Translation: {0}", id));
#endif
		}

		public override string GetValue(IDictionary<string, string> templates, IDictionary<string, string> values) {
			var value = values[Source.Id];

			if (Translations.ContainsKey(value))
				value = Translations[value].GetValue(templates, values);

			if (value == null && Translations.ContainsKey(""))
				value = Translations[""].GetValue(templates, values);

			values[Id] = value;
			return values[Id];
		}
	}
}