﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using OAI.Util;

namespace ServiceCore.ServiceComponents
{
	public class Field : NamedData {
		public String Value { get; private set; }
		public String Type { get; set; }
		public bool IsIdentifier { get; private set; }
		public Field(string id, string value, bool isIdentifier) {
			Id = id;
			Value = value;
			IsIdentifier = isIdentifier;
#if DEBUG
			//Debug.WriteLine(string.Format("Field: {0}", id));
#endif
		}

		public override string GetValue(IDictionary<string, string> templates, IDictionary<string, string> values) {
			return OAIUtil.XmlEncode(values[Id]);
		}
	}
}