﻿using System.Collections.Generic;
using ServiceCore.ServiceComponents;

namespace ServiceCore.ServiceComponents {
	public class ProtocolDescription {
		public DataSource DataSource { get; set; }
		public Dictionary<string, NamedData> Data { get; private set; }
		public Dictionary<string, Field> Fields { get; private set; }
		public Dictionary<string, Collection> Collections { get; private set; }
		public Dictionary<string, Constant> Constants { get; private set; }
		public List<string> OrderedDataKeys { get; private set; }
		public Output Output { get; private set; }
		public string Schema { get; private set; }
		public string NameSpace { get; private set; }
		public string ContentType { get; private set; }

		public Field IdentifierField {
			get {
				foreach (var field in Fields.Values) {
					if (field.IsIdentifier)
						return field;
				}

				return null;
			}
		}

		public ProtocolDescription(string schema, string ns, string contentType, Dictionary<string, Constant> constants) {
			Schema = schema;
			NameSpace = ns;
			ContentType = contentType;
			Data = new Dictionary<string, NamedData>();
			OrderedDataKeys = new List<string>();
			Fields = new Dictionary<string, Field>();
			Collections = new Dictionary<string, Collection>();
			Constants = constants;
			Output = new Output();
		}
	}
}